<?php
/**
 * @filename TokenFactory.php
 * @author Jerry Yan <792602257@qq.com>
 * @date 2020/12/17 14:48
 */


namespace JerryYan\DSL\Token;


class TokenFactory
{
    /** @var array<string, string> Token类型及映射类 */
    private $tokenMap = [
        Token::AND => TokenAnd::class,
        Token::OR => TokenOr::class,
    ];

    protected $tokenNameMap = [

    ];

    public function getTokenByName(string $name): TokenInterface
    {
        if (!isset($this->tokenNameMap[$name])) {
            return new TokenUndefined();
        }
        $tokenType = $this->tokenNameMap[$name];
        if (!isset($this->tokenMap[$tokenType])) {
            return new TokenUndefined();
        }
        return new $this->tokenMap[$tokenType];
    }
}